UIPackage
Menu

Framework

Change language

Boilerplate repo

Chord Chart

chord-chartui

Chord diagram around Apache ECharts. Circular nodes with weighted ribbons and adjacency focus. Theme-aware via registry tokens.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/chord-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/chord-chartInstalls to:app/components/ui/charts/chord-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
nodes{ name: string }[]required
links{ source: string; target: string; value: number }[]required
heightnumber | string380optional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/chord-chart/ChordChart.vue2.4 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { ChordChart as EChartsChordChart } from 'echarts/charts'
    import { TooltipComponent, LegendComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import {
      chartColors,
      chartTextColor,
      chartTooltipBg,
      chartTooltipBorder,
      chartTooltipText,
      mergeOptionBlock,
    } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsChordChart, TooltipComponent, LegendComponent])
    
    interface Props {
      nodes: { name: string }[]
      links: { source: string; target: string; value: number }[]
      height?: number | string
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      height: 380,
    })
    
    const mergedOption = computed(() => {
      const series = [
        {
          type: 'chord',
          data: props.nodes,
          links: props.links,
          padAngle: 4,
          minAngle: 3,
          label: { color: chartTextColor.value, fontSize: 11 },
          lineStyle: { opacity: 0.5 },
          emphasis: { focus: 'adjacency', lineStyle: { opacity: 0.9 } },
        },
      ]
      const userOption: any = props.option ?? {}
      const { series: userSeries, tooltip: userTooltip, legend: userLegend, ...userRest } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
      return {
        color: chartColors.value,
        tooltip: mergeOptionBlock(
          {
            trigger: 'item',
            backgroundColor: chartTooltipBg.value,
            borderColor: chartTooltipBorder.value,
            textStyle: { color: chartTooltipText.value, fontSize: 12 },
          },
          userTooltip,
        ),
        legend: mergeOptionBlock(
          {
            bottom: 0,
            icon: 'circle',
            itemWidth: 8,
            itemHeight: 8,
            textStyle: { fontSize: 11, color: chartTextColor.value },
          },
          userLegend,
        ),
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/chord-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/chord-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Chord Chart

chord-chartui

React mirror of @uipkge/chord-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/chord-chart.json
Named registry:npx shadcn@latest add @uipkge-react/chord-chartInstalls to:components/ui/charts/chord-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
nodes{ name: string }[]required
links{ source: string; target: string; value: number }[]required
heightnumber | string380optional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/chord-chart/ChordChart.tsx2.2 kB
    'use client'
    
    import * as React from 'react'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme, mergeOptionBlock } from '../useChartTheme'
    
    // ChordChart
    // ─────────────────────────────────────────────────────────────────────────
    
    export interface ChordChartProps {
      nodes: { name: string }[]
      links: { source: string; target: string; value: number }[]
      height?: number | string
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const ChordChart = React.forwardRef<HTMLDivElement, ChordChartProps>(
      ({ nodes, links, height = 380, option, className, ariaLabel }, ref) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const series = [
            {
              type: 'chord',
              data: nodes,
              links,
              padAngle: 4,
              minAngle: 3,
              label: { color: theme.textColor, fontSize: 11 },
              lineStyle: { opacity: 0.5 },
              emphasis: { focus: 'adjacency', lineStyle: { opacity: 0.9 } },
            },
          ]
          const userOption: any = option ?? {}
          const { series: userSeries, tooltip: userTooltip, legend: userLegend, ...userRest } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
          return {
            color: theme.colors,
            tooltip: mergeOptionBlock(
              {
                trigger: 'item',
                backgroundColor: theme.tooltipBg,
                borderColor: theme.tooltipBorder,
                textStyle: { color: theme.tooltipText, fontSize: 12 },
              },
              userTooltip,
            ),
            legend: mergeOptionBlock(
              {
                bottom: 0,
                icon: 'circle',
                itemWidth: 8,
                itemHeight: 8,
                textStyle: { fontSize: 11, color: theme.textColor },
              },
              userLegend,
            ),
            series: mergedSeries,
            ...userRest,
          }
        }, [nodes, links, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    ChordChart.displayName = 'ChordChart'
    
  • components/ui/charts/chord-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/chord-chart.json